<?php
function renderWikiText( $text, $topic, $web ) {
	global $_SITE;

	/* Shamelessly stolen from TWiki. */
	$lines = split( "\n", $text );

	/* Prepare for rendering loop. */
	reset($lines);
	$insidePRE = false;
	$insideTABLE = false;

	$inList = false;
	$listDepth = 0;
	$listEnd = "";

	/* Rendering loop. */
	while( list( $key, $value ) = each($lines) ) {
		if( preg_match( "/<PRE>/i", $value ) ) { $insidePRE = true; }
		if( preg_match( "@</PRE>@i", $value ) ) { $insidePRE = false; }

		if( $insidePRE ) {
			/* Insert custom rendering code here. */
			} /* end if insidePRE */
		else {
			/* Swapped blockquote/embedded HTML from
			   TWiki's order because quoting something
			   with embedded HTML does Really Bad Things. */

			/* embedded HTML */
			$TT = "\263";
			$value = preg_replace(
				"/\<(\!\-\-)/", "$TT\\1$TT", $value );
			$value = preg_replace(
				"/(\-\-)\>/", "\\1$TT", $value );
			$value = preg_replace(
				"/\<(\S.*?)\>/", "$TT\\1$TT", $value );
			$value = preg_replace( "/</", "&lt;", $value );
			$value = preg_replace( "/>/", "&gt;", $value );
			$value = preg_replace(
				"/$TT(\S.*?)$TT/", "<\\1>", $value );
			$value = preg_replace(
				"/(\-\-)$TT/", "\\1>", $value );
			$value = preg_replace(
				"/$TT(\!\-\-)/", "<\\1", $value );	

			/* Blockquote */
			$value = preg_replace( "/^>(.*?)$/", "&gt;<cite>\\1</cite><BR>", $value );
			
			/* FIXME : embedded-URL IMAGE links */
			$value = preg_replace(
				"@(^|[\-\*\s])((http|ftp|gopher|news|https)\:(\S+[^\s\.,!\?;:]))@",
				"\\1<a href=\"\\2\">\\2</a>", $value );
			
			/* entities */
			$value = preg_replace(
				"/&(\w+?);/", "$TT\\1;", $value );
			$value = preg_replace(
				"/&(\#[0-9]+);/", "$TT\\1;", $value );
			$value = preg_replace(
				"/&/", "&amp;", $value );
			$value = preg_replace(
				"/$TT/", "&", $value );

			$value = preg_replace(
				"/^----*/", "<HR>", $value );
			$value = preg_replace(
				"@^([a-zA-Z0-9]+)----*@",
				"<table width=\"100%\"><tr><td valign=\"bottom\"><h2>\\1</h2></td><td width=\"98%\" valign=\"middle\"><HR></td></tr></table>",
				$value );

			/* table of format "| cell | [ cell | ]*" */
			if( preg_match( "/^(\s*)\|.*\|(\s*)$/", $value ) ) {
				if( $insideTABLE ) {
					$value = preg_replace(
						"/^(\s*)\|(\s*)(.*)/",
						"\\1<TR><TD>\\3",
						$value );
					}
				else {
					$value = preg_replace(
						"/^(\s*)\|(\s*)(.*)/",
						"\\1<table border=\"2\" cellspacing=\"2\" cellpadding=\"2\"><TR><TD>\\3",
						$value );
					}	
				
				$value = preg_replace(
					"/\|(\s*)$/",
					"</TD></TR>",
					$value );
				$value = preg_replace(
					"/\|/", "</TD><TD>", $value );
				$insideTABLE = true;
				}
			else if ( $insideTABLE ) {
				$value = "</TABLE>" . $value;
				$insideTABLE = false;
				}

			/* lists */
			if( preg_match( "/^\S+?/", $value ) && $inList == true ) {
				/* not a list item */
				$listDepth = 0;
				$inList = false;
				$value = $listEnd . $value;
				$listEnd = "";
				} $endOfList = true;

			/* Moving this to a function would be hazardous. */
			if( preg_match( "/^((?:(?:   )|\t)+)(\S+?):\s/", $value, $matches ) ) {
				/* definition list item */
				$inList = true;
				$endOfList = false;
				$listItemDepth = strlen( $matches[1] );
				if( preg_match( "/ +/", $matches[1] ) ) {
					$listItemDepth = $listItemDepth / 3;
					}

				$prepend = "";
				$indent = 0;
				while( $listItemDepth > $listDepth ) {
					$prepend = "<DL> " . $prepend;
					$listEnd = "</DL> " . $listEnd;
					$listDepth = $listDepth + 1;
					$indent = 1;
					}
				while( $listItemDepth < $listDepth ) {
					$closing = substr( $listEnd, 0, 6 );
					$listEnd = substr( $listEnd, 6 );
					$prepend = $closing . $prepend;
					$listDepth = $listDepth - 1;		
					$indent = -1;
					}
				
				/* Am I in the same kind of list? */
				$closing = substr( $listEnd, 0, 6 );
				if( $closing != "</DL> " ) {
					$prepend = $prepend . "<DL> ";
					$listEnd = "</DL> " . $listEnd;
					$listDepth = $listDepth + 1;
					}

				$value = preg_replace( "/^((?:(?:   )|\t)+)(\S+?):\s/",
					      $prepend . "<DT> \\2: <DD> ",	
					      $value );
				} /* end definition list item */

			if( preg_match( "/^((?:(?:   )|\t)+)\* /", $value, $matches ) ) {
				/* unorded list item */
				$inList = true;
				$endOfList = false;
				$listItemDepth = strlen( $matches[1] );
				if( preg_match( "/ +/", $matches[1] ) ) {
					$listItemDepth = $listItemDepth / 3;
					}

				$prepend = "";
				while( $listItemDepth > $listDepth ) {
					$prepend = "<UL> " . $prepend;
					$listEnd = "</UL> " . $listEnd;
					$listDepth = $listDepth + 1;
					}
				while( $listItemDepth < $listDepth ) {
					$closing = substr( $listEnd, 0, 6 );
					$listEnd = substr( $listEnd, 6 );
					$prepend = $closing . $prepend;
					$listDepth = $listDepth - 1;
					}

				/* Am I in the same kind of list? */
				$closing = substr( $listEnd, 0, 6 );
				if( $closing != "</UL> " ) {
					$prepend = $prepend . "<UL> ";
					$listEnd = "</UL> " . $listEnd;
					$listDepth = $listDepth + 1;
					}
				
				$value = preg_replace( "/^((?:(?:   )|\t)+)\* /",
					      $prepend . "<LI> ",	
					      $value );
				} /* end unordered list item */

			if( preg_match( "/^((?:(?:   )|\t)+)((# )|(\d+\.?))/", $value, $matches ) ) {
				/* ordered list item */
				$inList = true;
				$endOfList = false;
				$listItemDepth = strlen( $matches[1] );
				if( preg_match( "/ +/", $matches[1] ) ) {
					$listItemDepth = $listItemDepth / 3;
					}

				$prepend = "";
				while( $listItemDepth > $listDepth ) {
					$prepend = "<OL> " . $prepend;
					$listEnd = "</OL> " . $listEnd;
					$listDepth = $listDepth + 1;
					}
				while( $listItemDepth < $listDepth ) {
					$closing = substr( $listEnd, 0, 6 );
					$listEnd = substr( $listEnd, 6 );
					$prepend = $closing . $prepend;
					$listDepth = $listDepth - 1;
					}

				/* Am I in the same kind of list? */
				$closing = substr( $listEnd, 0, 6 );
				if( $closing != "</OL> " ) {
					$prepend = $prepend . "<OL> ";
					$listEnd = "</OL> " . $listEnd;
					$listDepth = $listDepth + 1;
					}
				
				$value = preg_replace( "/^((?:(?:   )|\t)+)((# )|(\d+\.?))/",
					      $prepend . "<LI> ",	
					      $value );
				} /* end ordered list item */

			if( $endOfList && $inList ) {
				/* I found no list items,
				   but I /was/ in a list. */
				$listDepth = 0;
				$inList = false;
				$value = $listEnd . $value;
				$listEnd = "";
				}				

			/* blank lines become paragraphs */
			$value = preg_replace( "/^(\s*)$/", "</P><P>", $value );

			/* mailto */
			$value = preg_replace( 
				"#(^|[\s\(])(?:mailto\:)*([a-zA-Z0-9\-\_\.]+@[a-zA-Z0-9\-\_\.]+)(?=[\s\)]|$)#",
				'\\1<a href="mailto:\\2">\\2</a>',
				$value );

			/* WikiLinks! */
			$value = preg_replace(
				"/(^|[\*\s][\(\-\*\s]*)\[\[([A-Z]+[a-z]*)\.([\w\s]+)\]\]/",
				'\\1<a href="' . $_SITE["docrootdir"] .
				'view.php3?topic=\\3&web=\\2">' . $TT . "\\3" . $TT . '</a>' .
				'<wikitopic \\3 /wikitopic>',
				$value );
			$value = preg_replace(
				"/(^|[\*\s][\(\-\*\s]*)\[\[([\w\s]+)\]\]/",
				'\\1<a href="' . $_SITE["docrootdir"] .
				'view.php3?topic=\\2&web=' . $web . '">\\2</a>' .
				'<wikitopic \\2 /wikitopic>',
				$value );

			$value = preg_replace(
				"/(^|[\*\s][\(\-\*\s]*)([A-Z]+[a-z]*)\.([A-Z]+[a-z]+(?:[A-Z]+[a-zA-Z0-9]*))/",
				'\\1<a href="' . $_SITE["docrootdir"] .
				'view.php3?topic=\\3&web=\\2">' . $TT . "\\3" . $TT . '</a>' .
				'<wikitopic \\3 /wikitopic>',
				$value );
			$value = preg_replace(
				"/(^|[\*\s][\(\-\*\s]*)([A-Z]+[a-z]+(?:[A-Z]+[a-zA-Z0-9]*))/",
				'\\1<a href="' . $_SITE["docrootdir"] .
				'view.php3?topic=\\2&web=' . $web . '">\\2</a>' .
				'<wikitopic \\2 /wikitopic>',
				$value );
			$value = preg_replace( "/" . $TT . "(.*?)" . $TT . "/",
				"\\1", $value );

/* jQuinn -- I dropped this because it caused Bad Things to
   happen to attributes in HTML tags that were all-capitals.
   Won't help with MixedCase attributes, but hopefully nobody
   will try to use those.

   Real fix is to force all HTML attribute values to lower case,
   but it's tricky to do that without lowercasing stuff in quotes.

   TODO -- force HTML attributes to lower case

			$value = preg_replace(
				"/(^|[\*\s][\-\*\s]*)([A-Z]{3,})/",
				'\\1<a href="' . $_SITE["docrootdir"] .
				'view.php3?topic=\\2&web=' . $web . '">\\2</a>' .
				'<wikitopic \\2 /wikitopic>',
				$value );
*/
			$value = preg_replace(
				"/<link>(.*?)<\/link>/",
				'<a href="' . $_SITE["docrootdir"] .
				'view.php3?topic=\\1&web=' . $web . '">\\1</a>' .
				'<wikitopic \\1 /wikitopic>',
				$value );

			/* A few custom markups. */
		
			/* '*' and '_' as bold and underline, respectively. */
			$value = preg_replace(
				"/(^|\s)\*_([^\s].*?[^\s])_\*(\s|$)/",
				"\\1<STRONG><EM>\\2</EM></STRONG>\\3",
				$value );
			$value = preg_replace(
				"/(^|\s)_\*([^\s].*?[^\s])\*_(\s|$)/",
				"\\1<STRONG><EM>\\2</EM></STRONG>\\3",
				$value );
			$value = preg_replace(
				"/(^|\s)\*([^\s].*?[^\s])\*(\s|$)/",
				"\\1<STRONG>\\2</STRONG>\\3",
				$value );
			$value = preg_replace(
				"/(^|\s)_([^\s].*?[^\s])_(\s|$)/",
				"\\1<EM>\\2</EM>\\3",
				$value );

			/* link styles from JOSwiki */
			$value = preg_replace(
				"/(^|\s|\()\%([^\s].*?[^\s]):([^\s].*?[^\s])\%/",
				'\\1<a href="' . $_SITE["docrootdir"] .
				'view.php3?topic=\\3&web=\\2">\\2:\\3</a>' .
				'<wikitopic \\3 /wikitopic>',
				$value );
			$value = preg_replace(
				"/(^|\s|\()\%([^\s].*?[^\s])\%/",
				'\\1<a href="' . $_SITE["docrootdir"] .
				'view.php3?topic=\\2&web=' . $web . '">\\2</a>' .
				'<wikitopic \\2 /wikitopic>',
				$value );
			$value = preg_replace(
				"/(^|\s|\()\%([a-zA-Z0-9]+)\.(.*?[^\s])\%(\s|\)|$)/",
				'\\1<a href="' . $_SITE["docrootdir"] .
				'view.php3?topic=\\3&web=\\2">\\3</a>' .
				'<wikitopic \\3 /wikitopic>',
				$value );				
				
			} /* end if not insidePRE */

		/* Store the rendering done so far. */
		$result = $result . "\n" . $value;
		} /* end rendering loop */
	
	/* Take care of some terminal conditions. */
	if( $insideTABLE ) { $result = $result . "</TABLE>\n"; }
	if( $insidePRE ) { $result = $result . "</PRE>\n"; }
	$result = $result . $listEnd;

	/* Return the finished product. */
	return "<P>" . $result . "</P>";
} /* end renderWikiText() */

function stripLinks( $render_text ) {
	preg_match_all( "/(\<wikitopic )([^<>]*)( \/wikitopic\>)/",  $render_text, $matches );
	return $matches[2];
} /* end stripLinks() */

function saveWikiTopic($topic, $web, $body_text, $summary) {
global $_SITE;

/* generate the rendertext */
$render_text = renderWikiText( stripslashes($body_text), $topic, $web );

/* generate the list of links from this page*/
$matches = stripLinks( $render_text );
if( sizeof($matches) == 0 ) {
	$links_from = "";
	$lfcount = 0;
	}
else {
	reset($matches);
	do {
		$lfarray[current($matches)] = current($matches);
		} while( next($matches) );
	$lfcount = sizeof($lfarray);
	$links_from = implode( " ", $lfarray );
	$links_from = " " . $links_from . " ";
	}

if( ! ereg( "\[format-$web-.*\]", $topic ) ) {
        /* fetch the header and footer, */ 
        $header_text = fetchWebHeader($web);
        $footer_text = fetchWebFooter($web);

	/* render them, */
        exec( "echo '<?php \$topic = \"$topic\"; \$web = \"$web\"; ?> $header_text' | " .
			$_SITE["phpcgi"] . " -q", $header_render );
        exec( "echo '<?php \$topic = \"$topic\"; \$web = \"$web\"; ?> $footer_text' | " . 
			$_SITE["phpcgi"] . " -q", $footer_render );

	/* and store them in proper form */
        $header_text = implode( "\n", $header_render );
        $footer_text = implode( "\n", $footer_render );
        } else {
        $header_text = $footer_text = "";
	/* until we can protect against malicious PHP --
	   e.g. at least with user id's --
	   don't allow web editing of the headers
	   and footers. */
	print( "<TT>function disabled for security reasons<BR></TT>" );
	return false;
        }

$render_text = $header_text . $render_text . $footer_text;

/* we must escape the quotes from our
   inputs.  Because PHP doesn't need the slashes,
   don't over-write the originals. */
$body_textsl = addslashes($body_text);
$render_textsl = addslashes($render_text);
$websl = addslashes($web);
$topicsl = addslashes($topic);
$summarysl = addslashes($summary);
$links_fromsl = addslashes($links_from);

/* Calling fetchNumber() breaks the database connection for some reason... */
$ltcount = fetchNumber( "SELECT COUNT(*) FROM " . $_SITE["dbtable"] . " WHERE " . 
                        "linksfrom REGEXP \" " . $topic . " \";" );

/* Update the node count. */
$db = getDatabase();
$oldlf = mysql_query( "SELECT linksfrom FROM " . $_SITE["dbtable"] . " WHERE topic=\"" . $topic . "\";", $db );
mysql_close( $db );
$oldlff = mysql_fetch_array( $oldlf );
$old_links_from = $oldlff["linksfrom"];
$arrayx = split( " ", $old_links_from );
for( $ii = 0; $ii < sizeof( $arrayx ); $ii++ ) {
	$linkfrom = $arrayx[$ii];
	if( $linkfrom == "" ) { continue; }
	if( $linkfrom == $topic ) { continue; }
	$db = getDatabase();
	mysql_query( "UPDATE " . $_SITE["dbtable"] . " SET ltcount = ltcount - 1 WHERE topic = \"" . $linkfrom . "\";", $db );
	mysql_close( $db );
	}

$db = getDatabase();
/* perform the save query */
$result = mysql_query( "REPLACE INTO " . $_SITE["dbtable"] . " " .
	"(topic,web,summary,rendertext,full_text,linksfrom,lfcount,ltcount,lastedit) " .
	"VALUES (\"$topicsl\", \"$websl\", \"$summarysl\", \"$render_textsl\", \"$body_textsl\", \"$links_fromsl\", \"$lfcount\", \"$ltcount\", NOW() );", $db );
if( ! $result ) {
	$error_body = mysql_error($db) . " (" . mysql_errno($db) . ")";
        mysql_close( $db );
        include( $_SITE["mirrordir"] . "query_failed.ihtml" );
        return false;
        }
mysql_close( $db );

/* Update the node count. */
$arrayx = split( " ", $links_from );
for( $ii = 0; $ii < sizeof($arrayx); $ii++ ) {
	$linkfrom = $arrayx[$ii];
	if( $linkfrom == "" ) { continue; }
	if( $linkfrom == $topic ) { continue; }
	$db = getDatabase();
	mysql_query( "UPDATE " . $_SITE["dbtable"] . " SET ltcount = ltcount + 1 WHERE topic = \"" . $linkfrom . "\";", $db );
	mysql_close( $db );
	}

return true;
} /* end saveWikiTopic() */

function fetchNumber( $query ) {
	global $_SITE;

	/* Why can't I pass database connection indices around?
	   I can't seem to reuse them up above, either... */
	$db = getDatabase();
	$result = mysql_query( $query, $db );

	if( ! $result ) {
        	$error_body = mysql_error($db) . " (" . mysql_errno($db) . ")";
	        include( $_SITE["mirrordir"] . "query_failed.ihtml" );

	        mysql_close( $db );
        	return false;
        	}
	
	$row = mysql_fetch_row($result);
	$count = $row[0];
	mysql_close( $db );	
	if( $count == "" ) { return 0; } else { return $count; }
} /* end fetchNumber() */
?>
